Index: trunk/lib/Text/FormBuilder/Parser.pm
===================================================================
--- trunk/lib/Text/FormBuilder/Parser.pm	(revision 1)
+++ trunk/lib/Text/FormBuilder/Parser.pm	(revision 10)
@@ -7623,5 +8139,140 @@
                                                         'name' => 'pattern_def',
                                                         'vars' => '',
-                                                        'line' => 28
+                                                        'line' => 40
+                                                      }, 'Parse::RecDescent::Rule' ),
+                              'dynamic_list' => bless( {
+                                                         'impcount' => 0,
+                                                         'calls' => [],
+                                                         'changed' => 0,
+                                                         'opcount' => 0,
+                                                         'prods' => [
+                                                                      bless( {
+                                                                               'number' => '0',
+                                                                               'strcount' => 1,
+                                                                               'dircount' => 1,
+                                                                               'uncommit' => undef,
+                                                                               'error' => undef,
+                                                                               'patcount' => 0,
+                                                                               'actcount' => 1,
+                                                                               'items' => [
+                                                                                            bless( {
+                                                                                                     'pattern' => '&',
+                                                                                                     'hashname' => '__STRING1__',
+                                                                                                     'description' => '\'&\'',
+                                                                                                     'lookahead' => 0,
+                                                                                                     'line' => 19
+                                                                                                   }, 'Parse::RecDescent::Literal' ),
+                                                                                            bless( {
+                                                                                                     'hashname' => '__DIRECTIVE1__',
+                                                                                                     'name' => '<perl_codeblock>',
+                                                                                                     'lookahead' => 0,
+                                                                                                     'line' => 19,
+                                                                                                     'code' => 'Text::Balanced::extract_codeblock($text,undef,$skip,\'{}\');
+					'
+                                                                                                   }, 'Parse::RecDescent::Directive' ),
+                                                                                            bless( {
+                                                                                                     'hashname' => '__ACTION1__',
+                                                                                                     'lookahead' => 0,
+                                                                                                     'line' => 20,
+                                                                                                     'code' => '{
+	my @results = (eval $item[2]);
+	if (ref $results[0] eq \'HASH\') {
+	    @options = @results;
+	} else {    
+	    @options = map { { $_ => $_ } } @results;
+	}
+    }'
+                                                                                                   }, 'Parse::RecDescent::Action' )
+                                                                                          ],
+                                                                               'line' => undef
+                                                                             }, 'Parse::RecDescent::Production' )
+                                                                    ],
+                                                         'name' => 'dynamic_list',
+                                                         'vars' => '',
+                                                         'line' => 19
+                                                       }, 'Parse::RecDescent::Rule' ),
+                              'static_list' => bless( {
+                                                        'impcount' => 0,
+                                                        'calls' => [
+                                                                     'option'
+                                                                   ],
+                                                        'changed' => 0,
+                                                        'opcount' => 0,
+                                                        'prods' => [
+                                                                     bless( {
+                                                                              'number' => '0',
+                                                                              'strcount' => 2,
+                                                                              'dircount' => 1,
+                                                                              'uncommit' => undef,
+                                                                              'error' => undef,
+                                                                              'patcount' => 2,
+                                                                              'actcount' => 0,
+                                                                              'op' => [],
+                                                                              'items' => [
+                                                                                           bless( {
+                                                                                                    'pattern' => '{',
+                                                                                                    'hashname' => '__STRING1__',
+                                                                                                    'description' => '\'\\{\'',
+                                                                                                    'lookahead' => 0,
+                                                                                                    'line' => 17
+                                                                                                  }, 'Parse::RecDescent::Literal' ),
+                                                                                           bless( {
+                                                                                                    'expected' => '<leftop: option /,\\\\s*/ option>',
+                                                                                                    'min' => 1,
+                                                                                                    'name' => '\'option(s)\'',
+                                                                                                    'max' => 100000000,
+                                                                                                    'leftarg' => bless( {
+                                                                                                                          'subrule' => 'option',
+                                                                                                                          'matchrule' => 0,
+                                                                                                                          'implicit' => undef,
+                                                                                                                          'argcode' => undef,
+                                                                                                                          'lookahead' => 0,
+                                                                                                                          'line' => 17
+                                                                                                                        }, 'Parse::RecDescent::Subrule' ),
+                                                                                                    'rightarg' => bless( {
+                                                                                                                           'subrule' => 'option',
+                                                                                                                           'matchrule' => 0,
+                                                                                                                           'implicit' => undef,
+                                                                                                                           'argcode' => undef,
+                                                                                                                           'lookahead' => 0,
+                                                                                                                           'line' => 17
+                                                                                                                         }, 'Parse::RecDescent::Subrule' ),
+                                                                                                    'hashname' => '__DIRECTIVE1__',
+                                                                                                    'type' => 'leftop',
+                                                                                                    'op' => bless( {
+                                                                                                                     'pattern' => ',\\s*',
+                                                                                                                     'hashname' => '__PATTERN1__',
+                                                                                                                     'description' => '/,\\\\s*/',
+                                                                                                                     'lookahead' => 0,
+                                                                                                                     'rdelim' => '/',
+                                                                                                                     'line' => 17,
+                                                                                                                     'mod' => '',
+                                                                                                                     'ldelim' => '/'
+                                                                                                                   }, 'Parse::RecDescent::Token' )
+                                                                                                  }, 'Parse::RecDescent::Operator' ),
+                                                                                           bless( {
+                                                                                                    'pattern' => ',?',
+                                                                                                    'hashname' => '__PATTERN2__',
+                                                                                                    'description' => '/,?/',
+                                                                                                    'lookahead' => 0,
+                                                                                                    'rdelim' => '/',
+                                                                                                    'line' => 17,
+                                                                                                    'mod' => '',
+                                                                                                    'ldelim' => '/'
+                                                                                                  }, 'Parse::RecDescent::Token' ),
+                                                                                           bless( {
+                                                                                                    'pattern' => '}',
+                                                                                                    'hashname' => '__STRING2__',
+                                                                                                    'description' => '\'\\}\'',
+                                                                                                    'lookahead' => 0,
+                                                                                                    'line' => 17
+                                                                                                  }, 'Parse::RecDescent::Literal' )
+                                                                                         ],
+                                                                              'line' => undef
+                                                                            }, 'Parse::RecDescent::Production' )
+                                                                   ],
+                                                        'name' => 'static_list',
+                                                        'vars' => '',
+                                                        'line' => 17
                                                       }, 'Parse::RecDescent::Rule' )
                             }
